#include <awali/dyn/modules/partial-id.hh>

#include <awali/dyn/algos/aliases.hh>

namespace awali { namespace dyn {


  automaton_t
  min_coquotient (automaton_t aut, param_t dir)
  {
    automaton_t res = min_quotient(transpose(aut),dir);
    transpose_here(res);
    return res;
  }


  automaton_t
  coquotient (automaton_t aut, std::vector<std::vector<state_t>>& equiv)
  {
    automaton_t res = quotient(transpose(aut), equiv);
    transpose_here(res);
    return res;
  }

  automaton_t
  right_reduce (automaton_t aut)
  {
      automaton_t res = left_reduce(transpose(aut));
      transpose_here(res);
      return res;
  }

}}
