#include <awali/dyn/bridge-sttc/explicit-automaton.cc>
#include <awali/sttc/algos/factor.hh>

#include<set-types.hh>

namespace awali {

  extern "C" dyn::automaton_t prefix(dyn::automaton_t aut) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    return dyn::make_automaton(sttc::prefix(a));
  }

  extern "C" void prefix_here(dyn::automaton_t aut) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    sttc::prefix_here(a);
  }

  extern "C" dyn::automaton_t suffix(dyn::automaton_t aut) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    return dyn::make_automaton(sttc::suffix(a));
  }

  extern "C" void suffix_here(dyn::automaton_t aut) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    sttc::suffix_here(a);
  }

  extern "C" dyn::automaton_t factor(dyn::automaton_t aut) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    return dyn::make_automaton(sttc::factor(a));
  }

  extern "C" void factor_here(dyn::automaton_t aut) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    sttc::factor_here(a);
  }

}
