#include <awali/dyn/bridge-sttc/explicit-automaton.cc>
#include <awali/sttc/algos/scc.hh>

#include<set-types.hh>

namespace awali {

  extern "C"
  std::pair< std::unordered_map<dyn::state_t, dyn::state_t>,
             std::vector<std::vector<dyn::state_t>> >
  scc_recursive(dyn::automaton_t aut) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    return sttc::scc_recursive(a);
  }


  extern "C"
  std::pair< std::unordered_map<dyn::state_t, dyn::state_t>,
             std::vector<std::vector<dyn::state_t>> >
  scc_iterative(dyn::automaton_t aut) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    return sttc::scc_iterative(a);
  }


  extern "C"
  std::pair< dyn::automaton_t,
             std::pair< std::unordered_map<dyn::state_t, dyn::state_t>,
                        std::vector<std::vector<dyn::state_t>> >  >
  condensation (dyn::automaton_t aut)
  {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    auto res= sttc::condensation(a);
    return { dyn::make_automaton(res.first), std::move(res.second) };
  }

  extern "C"
  std::vector<dyn::state_t>
  scc_of (dyn::automaton_t aut, dyn::state_t s)
  {
    auto sttc_aut= dyn::get_stc_automaton<context_t>(aut);
    return sttc::scc_of(sttc_aut, s);
  }
}
