#ifndef DYN_MODULES_PRODUCT_CC
#define DYN_MODULES_PRODUCT_CC

#include <unordered_map>
#include <awali/dyn/core/automaton.hh>
#include <awali/dyn/loading/handler.hh>

#include <awali/dyn/modules/product.hh>

namespace awali { namespace dyn {

    automaton_t product(automaton_t aut1, automaton_t aut2, bool keep_history) {
      return loading::call_mixte2<automaton_t, bool, &product>("product", "product", aut1, aut2, keep_history);
  }

  automaton_t shuffle(automaton_t aut1, automaton_t aut2, bool keep_history) {
    return loading::call_mixte2<automaton_t, bool, &shuffle>("shuffle", "product", aut1, aut2, keep_history);
  }

  automaton_t infiltration(automaton_t aut1, automaton_t aut2, bool keep_history) {
    return loading::call_mixte2<automaton_t, bool, &infiltration>("infiltration", "product", aut1, aut2, keep_history);
  }

  automaton_t Union(automaton_t aut1, automaton_t aut2) {
    return loading::call_mixte<automaton_t, &Union>("Union", "product", aut1, aut2);
  }

}}//end of ns awali::dyn

#endif
