#ifndef DYN_MODULES_PROPER_HH
#define DYN_MODULES_PROPER_HH

#include <awali/common/direction.hh>
#include <awali/dyn/core/automaton.hh>
#include <awali/dyn/core/abstract-ratexp.hh>

namespace awali { namespace dyn {
  void proper_here(automaton_t aut, param_t dir=param_t::BACKWARD,
                                                          bool prune=true);
  automaton_t proper(automaton_t aut, param_t dir =param_t::BACKWARD,
                                                          bool prune=true);
  bool is_proper(automaton_t aut);
  bool is_valid(automaton_t aut);
  automaton_t allow_eps_transition(automaton_t aut);
  automaton_t thompson(ratexp_t exp);
  automaton_t zpc(ratexp_t exp);
  automaton_t draw_exp(ratexp_t exp);


}}//end of ns awali::dyn

#endif
