#ifndef AWALI_STTC_WAUTOMATON_HH
#define AWALI_STTC_WAUTOMATON_HH
//We work with NFAs (thus the "weight" is Boolean"):
#include <awali/sttc/weightset/b.hh>
//The labels are letters implemented by char:
#include <awali/sttc/ctx/lal_char.hh>
#include <awali/sttc/core/mutable-automaton.hh>

namespace awali {
  namespace sttc {

    template<typename T>
    mutable_automaton<context<ctx::lal_char,T>>
      make_automaton(const std::initializer_list<char>& letters)
    {
      return make_shared_ptr<mutable_automaton<context<ctx::lal_char,T>>>
	(context<ctx::lal_char,T>(ctx::lal_char(letters),T()));
    }

    mutable_automaton<context<ctx::lal_char,b>>
      make_automaton(const std::initializer_list<char>& letters)
    {
      return make_automaton<b>(letters);
    }


  }
}

#endif
