#ifndef AWALI_CTX_TRAITS_HH
# define AWALI_CTX_TRAITS_HH

# include <memory>

#include <awali/sttc/core/rat/identities.hh> // FIXME: likely useless

namespace awali { namespace sttc {


  /// T without reference or const/volatile qualifiers.
  template <typename T>
  using base_t
    = typename std::remove_cv<typename std::remove_reference<T>::type>::type;

  /*------------------.
  | Computing types.  |
  `------------------*/

# define DEFINE(Type)                                                   \
  namespace internal                                                      \
  {                                                                     \
    template <typename ValueSet>                                        \
    struct Type ## _of_impl                                             \
    {                                                                   \
      using type = typename ValueSet::Type;                             \
    };                                                                  \
  }                                                                     \
                                                                        \
  template <typename ValueSet>                                          \
  using Type ## _of                                                     \
    = typename internal::Type ## _of_impl<base_t<ValueSet>>::type

  DEFINE(context_t);
  DEFINE(label_t);
  DEFINE(labelset_t);
  DEFINE(weight_t);
  DEFINE(weightset_t);

# undef DEFINE


  /*------------------.
  | shared pointers.  |
  `------------------*/

  // Forward traits about shared_ptr<T> to T.
  namespace internal
  {
# define DEFINE(Traits)                                         \
    template <typename ValueSet>                                \
    struct Traits ## _t_of_impl<std::shared_ptr<ValueSet>>      \
      : Traits ## _t_of_impl<base_t<ValueSet>>                  \
    {}

    DEFINE(context);
    DEFINE(label);
    DEFINE(labelset);
    DEFINE(weight);
    DEFINE(weightset);
# undef DEFINE
  }
}}//end of ns awali::stc

#endif // !AWALI_CTX_TRAITS_HH
