#ifndef AWALI_EMPTY_HH
# define AWALI_EMPTY_HH

# include <functional> // std::hash
# include <iostream>

namespace awali {
  namespace sttc {

    /// Empty labels, for LAO.
    struct empty_t
    {};

    // So that we can make a map with empty_t as key, for
    // mutable_automaton's entries.
    inline
    bool operator<(empty_t, empty_t)
    {
      return false;
    }

    // For unordered containers.
    inline
    bool operator==(empty_t, empty_t)
    {
      return true;
    }
  }
}//end of ns awali::stc

namespace std
{
  // For unordered containers.
  template <>
  struct hash<awali::sttc::empty_t>
  {
    size_t operator()(awali::sttc::empty_t) const
    {
      return 0;
    }
  };

  std::ostream& operator<< (std::ostream& o, const awali::sttc::empty_t& e) {
    return o;
  }
}


#endif // !AWALI_EMPTY_HH
