#include <awali/sttc/automaton.hh>
#include <awali/sttc/algos/js_print.hh>
#include <awali/sttc/algos/determinize.hh>

//Static features are defined in the awali namespace
using namespace awali::sttc;

int main() {
  /* The NFA factory requires a list of char letters and returns an empty
     mutable automaton.
  */
  auto aut=make_automaton({'a','b'});

  unsigned s[3];
  for(int i=0; i<3; i++)
    s[i]=aut->add_state();
  /* a mutable_automaton is actually a (shared) pointer;
     to call the method, one have to use ->
  */
  aut->set_initial(s[0]);
  aut->set_final(s[2]);
  aut->set_transition(s[0], s[0], 'a');
  aut->set_transition(s[0], s[0], 'b');
  aut->set_transition(s[0], s[1], 'a');
  aut->set_transition(s[1], s[2], 'b');
  aut->set_transition(s[2], s[2], 'a');
  aut->set_transition(s[2], s[2], 'b');
  //print a json description of the automaton:
  js_print(aut, std::cout) << std::endl;

  auto det=determinize(aut);
  //print a json description of the determinization:
  std::cout << "Determinization:" << std::endl;
  js_print(det, std::cout) << std::endl;


}
